package com.fp.persistence.pviaticos.param;

import javax.persistence.Column;

import java.io.Serializable;

import com.fp.dto.hb.HibernateId;

import java.lang.reflect.Field;

import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de VIA_DIAS_ACUMULADOS*/
@Embeddable
public class ViaDiasAcumuladosKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="COD_EMPLEADO", nullable=false,updatable=false)

/**
* Codigo de estatus de la solicitud de viaticos
*/
private String cod_empleado;

@Column(name="COD_EJERCICIO", nullable=false,updatable=false)

/**
* Anio asociado a los dias acumulados
*/
private Integer cod_ejercicio;

@Column(name="COD_DESTINO", nullable=true)

/**
* Descripcion default del tipo de tabla de pagos
*/
private String cod_destino;

/**Contructor por defecto*/
public ViaDiasAcumuladosKey(){}
/**Contructor de ViaDiasAcumuladosKey
@param pCod_empleado Codigo de estatus de la solicitud de viaticos
@param pCod_ejercicio Anio asociado a los dias acumulados
*/
public ViaDiasAcumuladosKey(String pCod_empleado,Integer pCod_ejercicio, String pCod_destino){
 cod_empleado=pCod_empleado;
 cod_ejercicio=pCod_ejercicio;
 cod_destino=pCod_destino;
}
/**Obtiene el valor de cod_empleado
@return valor de cod_empleado*/
public String getCod_empleado(){
  return cod_empleado;
}
/**Fija el valor de cod_empleado
@param pCod_empleado nuevo Valor de cod_empleado*/
public void setCod_empleado(String pCod_empleado){
  cod_empleado=pCod_empleado;
}

/**Obtiene el valor de cod_ejercicio
@return valor de cod_ejercicio*/
public Integer getCod_ejercicio(){
  return cod_ejercicio;
}
/**Fija el valor de cod_ejercicio
@param pCod_ejercicio nuevo Valor de cod_ejercicio*/
public void setCod_ejercicio(Integer pCod_ejercicio){
  cod_ejercicio=pCod_ejercicio;
}

/**Obtiene el valor de cod_destino
@return valor de cod_destino*/
public String getCod_destino(){
  return cod_destino;
}
/**Fija el valor de cod_destino
@param pCod_destino nuevo Valor de cod_destino*/
public void setCod_destino(String pCod_destino){
  cod_destino=pCod_destino;
}
/**Implementacion de la comparacion de ViaDiasAcumuladosKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof ViaDiasAcumuladosKey))return false;
  ViaDiasAcumuladosKey that = (ViaDiasAcumuladosKey) o;
  if (this.getCod_empleado() == null || that.getCod_empleado() == null){
      return false;
  }
  if (! this.getCod_empleado().equals(that.getCod_empleado())){
    return false;
  }
  if (this.getCod_ejercicio() == null || that.getCod_ejercicio() == null){
      return false;
  }
  if (! this.getCod_ejercicio().equals(that.getCod_ejercicio())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia ViaDiasAcumuladosKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCod_empleado() == null ? 0 : this.getCod_empleado().hashCode());
    result = result * 37 + (this.getCod_ejercicio() == null ? 0 : this.getCod_ejercicio().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
